;PRMON.COM: Packet-Radio-Monitorprogramm
;(C) DC1YB - Alle Rechte vorbehalten

ver equ '1.26'
code segment
    org 100h
assume cs:code,ds:code,es:code
start:jmp ini

irq   db 4          ;COM1-IRQ
com   dw 03f8h      ;COM1-Adr.
com2  db 3,0f8h,2
com3  db 2,0e8h,3   ;COM2,3,4:IRQ+Adr.
com4  db 5,0e8h,2

;Konstanten
bufl equ 4096 ;Pufferlnge (ca. 35 s bei 1200 Bd)
jms  equ <jmp short>
wp   equ <word ptr>
by   equ <byte ptr>
ofs  equ <offset>

;Makro: INT merken+setzen
setint macro nr,old,new
    mov ax,3500h+nr
    int 21h
    mov wp old,bx
    mov wp old[2],es
    mov dx,ofs new
    mov ax,2500h+nr
    int 21h
    endm

;Makro: INT rcksetzen
resint macro nr,old
    lds dx,es:old
    mov ax,2500h+nr
    int 21h
    endm

;Variablen
bd    dw 1988   ;Baudrate=1200
reob  dw ?      ;Zeichen+Attr.rechts oben
upsp  dw ?      ;User-PSP-Segm.
timer dw 36     ;Zeitscheibensteuerung
bits  db 8      ;Bitzhler
chr   db ?      ;Empfangenes Byte
bsy   db 0      ;Busy-Flag
base  db 10     ;Fr Dezimal-Konvertierung
rspz  db 'crh'  ;SSID-Zusatzbits
flgs  db 0      ;Optionen (AND-Maske): 1=/C, 2=Delay,
                ;4=Save, 8=resident, 16=Binrdaten anz.,
                ;32=Header mitspeichern, 128=Debug-Mode (/!)
hdr   db 0,13,10,32 ;Header fr EMAIL-Leser (dann "*" statt 0)
hdrl  equ $-ofs hdr
ext   db '.TXT',0
satx  db 'SABM de ',0
ditx  db 'DISC de ',0
uatx  db 'UA de ',0
dmtx  db 'DM de ',0

;Tab.mit IBM-Zeichen fr ANSI-Codes 160-255
ansi    db " #| cR', "
        db "AAAAEEEIIIIDOOx0UUUYp"
        db "aidoooyP"
ansilen equ $-ansi

;Neuer Tastatur-BIOS-INT 16H
new16:sti
    test ah,not 10h
    jnz n16a    ;AH=0/10h?
n16b:push ax
    or ah,1     ;Ja,Taste?
    pushf
    call cs:[old16]
    pop ax
    jnz n16a    ;Ja,holen
    call task16
    jms n16b    ;Nein,warten
n16a:call task16
    jmp cs:[old16]

;Neuer Timer-Interrupt
new1c:sti
    cmp cs:timer,0
    jz n1c1     ;File-Write-
    dec cs:timer;Timer
n1c1:jmp cs:[old1c]

;Neuer DOS-Interrupt
new21:sti
    call task16
    jmp cs:[old21]

;Lokaler Critical Error Handler
new24:mov al,3  ;Fail
    iret

;Neuer Spooler-INT
new28:sti
    call task28
    jmp cs:[old28]

;Task aufrufen (DS=CS, vorher
;mssen AX und DS gerettet sein)
task16:push bx ds
    lds bx,cs:dosf
    cmp by[bx],0
    pop ds bx   ;DOS busy?
    jz task28
    ret
task28:cmp cs:timer,0
    jnz tsk0    ;Zeit abgelaufen?
    push bx ds
    lds bx,cs:crit
    cmp by[bx],0
    pop ds bx   ;Critical Error?
    jz tsk2
tsk0:ret
tsk2:push ax ds
    mov ax,cs
    mov ds,ax
    mov bsy,-1
    mov wp olds[2],ss
    mov wp olds,sp
    cli
    mov ss,ax   ;Eigener Stack
    mov sp,ofs last
    sti
    push bx cx dx si di es
    mov es,ax   ;ES=CS
    call slice  ;Timer laden
    mov al,':'  ;Task-Tick im
    call debug  ;Debug-Mode anz.
    mov ah,62h
    int 21h
    mov upsp,bx ;User-PSP merken
    mov bx,cs
    mov ah,50h  ;Auf eigenen PSP
    int 21h     ;umschalten
    cld
tsk3:call getp  ;Paket holen
    jnc tsk4    ;Ok,auswerten
    cmp bl,3
    je tsk1     ;Nix mehr da
    jms tsk3    ;CRC-Err.o..
tsk4:call time  ;Zeitstempel
    call chkbin ;Binrdaten?
    call store  ;Speichern
    mov al,'.'
    call debug
    jmp tsk3    ;Evtl.mehr?
tsk1:mov cx,5
tsk5:mov dx,com
    add dl,2    ;Hngt IRQ?
    in al,dx
    and al,3fh  ;0=Modemstatus-
    jnz tsk6    ;IRQ hngt
    loop tsk5
    add dl,4
    in al,dx    ;IRQ rcks.
tsk6:mov bx,upsp
    mov ah,50h  ;Auf User-PSP
    int 21h     ;zurckschalten
    pop es di si dx cx bx
    cli
    mov ss,wp olds[2]
    mov sp,wp olds
    sti
    mov bsy,0
    pop ds ax
    ret

;Timer mit Task-Zyklus laden
slice:mov cl,7
    mov bx,bufl
    mov ax,bd   ;Bd*Bufl/20357
    mul bx      ;=Task-Zyklus in
    mov bx,20357;1/18 s, z.B.
    div bx      ;1200 Bd, L=4096:
    mov timer,ax;t=22 Sek.
    ret

;COM-Interrupt-Routine
irqs:push ax bx cx dx ds
    mov ax,cs
    mov ds,ax   ;DS=CS
    mov dx,com
    add dl,6    ;Modem-Status-
    in al,dx    ;Reg. lesen:
    and al,1    ;CTS-Wechsel?
    jz irq1a    ;Nein, CD o..
    cli         ;Falls Chain...
    mov al,0
    out 43h,al  ;Timer 0 lesen
    in al,40h   ;(Latch-Mode)
    jmp $+2
    mov ah,al
    in al,40h
    xchg al,ah
    mov dx,tim
    sub dx,ax   ;DX=Zeitdiff.
    mov tim,ax
    mov ax,bd
    mov bx,ax
    shr ax,1    ;Zeit <0.5 bd:
    cmp dx,ax   ;Nur ein Spike
    jb irq1a
    add ax,bx   ;AX=1.5 bd
    xor cx,cx   ;CX= # 1-Bits
irq2:cmp dx,ax  ;vor dem 0-Bit
    jb irq5
    add ax,bx
    inc cx      ;Nur bis 7
    cmp cl,7    ;zhlen...
    jbe irq2
irq5:cmp cl,6   ;Sechs 1-Bits?
    jb irq0
    mov bx,anf
    ja irq9     ;>6: Unsinn
    cmp bits,7  ;0 vor 1111110?
    je irq8     ;Ja, ok: Flag
irq9:mov al,0   ;Sonst Rauschen
    call stobyt
    call stobyt ;Block lschen
    mov dl,8    ;Bitzhler=8
    jms irq6
irq8:mov cx,pnt1;CX=Lnge
    sub cx,bx   ;des Pakets
    jnc irq7
    add cx,bufl
irq7:sub cx,2   ;Lngenwort nicht
    jbe irq9    ;mitrechnen
    cmp cx,330
    ja irq9     ;Block zu lang
    mov al,cl
    call stobyt
    mov al,ch   ;Vorheriges
    call stobyt ;Lngenwort setzen
    mov bx,pnt1
    mov anf,bx  ;N.Lngenwort=0
    jmp irq9
irq1a:jms irq1
irq0:mov dl,bits
    mov bx,pnt1
    mov al,chr
    jcxz irq3
    mov ah,cl   ;CL merken
irq4:stc
    call stobit ;Erst 1-Bits...
    loop irq4
    cmp ah,5    ;Waren's 5?
    je irq6     ;0 weglassen!
irq3:clc
    call stobit ;...dann 0-Bit
irq6:mov chr,al
    mov bits,dl
    mov pnt1,bx
irq1:mov al,irq
    add al,60h
    pop ds dx cx bx
    out 20h,al  ;SEOI
    pop ax
    iret

;1 Bit speichern (=C),
;BX=PNT1,AL=CHR,DL=BITS!
stobit:rcr al,1
    dec dl
    jnz stob1
    mov dl,8
;1 Byte speichern (=AL)
stobyt:mov buf[bx],al
    inc bx
    cmp bx,bufl
    jb stob1
    xor bx,bx
stob1:ret

;Empfangenes Paket nach PAK umspeichern;
;Struktor dort: Calls,'',Daten;
;BH=PID (oder 0=keine Daten); AL=Steuerbyte,
;AH-Bits 0,1,2=Command,Response,Digi;
;C=1,BL=3/2/1 fr nix empfangen/
;Aufbau fehlerhaft/CRC falsch;
;C=0,BL=0 wenn Paket da und CRC ok;
;SI=Anfangsadresse des Datenteils;
;CX=Datenlnge,DI=Daten-Endadresse.
getp:push bp
    mov si,pnt2
    mov di,ofs pak
    mov bl,3    ;Returncode
    mov dx,si   ;Zeiger merken
    cli
    call rdbuf  ;CX aus dem
    mov cl,al   ;Puffer lesen
    call rdbuf  ;(Blocklnge)
    sti
    mov ch,al
    jcxz getpw  ;Nix da
    cmp cx,330  ;>330:Kann nur
    jbe getp4   ;Pufferberl.sein
    mov al,''
    call debug
    mov dx,anf  ;Paket vergessen
getpw:mov si,dx ;Nix da, Zeiger
getp3a:jmp getp3;zurck
getp4:dec bl
    mov dx,-1   ;CRC-Wort
    xor bh,bh   ;Call-Zhler
    mov by temp[1],bh
getp9:inc bh
    cmp bh,10
    ja getp0a   ;Max.10 Calls
    mov ah,6    ;Je 6 Zch.+SSID
getp2:jcxz getp3a
    dec cx
    call rdcrc
    shr al,1
    jc getpv    ;Nicht bei AX25!
    cmp al,' '
    ja getpv
    mov al,'-'  ;Spaces durch "-"
    clc         ;ersetzen
getpv:stosb
    jc getpx    ;X25 statt AX25?!
getp6:dec ah
    jnz getp2
    jcxz getp3a
    dec cx
    call rdcrc
    test al,128 ;Resp/Cmd-Bit
    jz getpu    ;bei Abs/Ziel-SSID
    cmp bh,2    ;oder H-Bit bei
    ja getpt    ;Digi-Call
    or by temp[1],bh
    jms getpu   ;merken
getpt:or by temp[1],4
getpu:shr al,1
    pushf       ;C=1:Ende
    and al,0fh  ;SSID
    add al,'0'
    cmp al,'9'  ;0...15
    jbe getpy   ;->"0-F"
    add al,7
getpy:stosb
    popf
    jc getpx    ;Letztes Call
    mov al,','  ;der Liste?
    stosb
    jmp getp9
getpx:mov al,'';Trennsymbol
    stosb
    cmp cx,3    ;Min.3 Bytes
    jb getp0    ;mten folgen!
    call rdcrc  ;Steuerbyte
    dec cx
    mov by temp,al
    cmp cx,259
getp0a:ja getp0 ;Max.PID+256 Byte+CRC
    xor bh,bh
    sub cx,2    ;#Datenbytes
    jz getp1
    dec cx
    call rdcrc  ;PID (F0=AX.25, CC=
    mov bh,al   ;TCP, BB=PACSAT)
getp1:jcxz getp5;Keine Daten
    mov bp,di   ;Anfangsadr.merken
getp8:call rdcrc
    test flgs,1
    jnz getpq   ;Wenn nicht /C:
    cmp al,26   ;LF+EOF ignor.
    je getps
    cmp al,10
    je getps
    stosb       ;Daten
    cmp al,13   ;umkopieren,
    jne getps   ;CR->CRLF
    mov al,10
    stosb
    cmp hdr,0   ;/E=undok. fr .M70
    jz getps    ;statt .TXT (Mbx-Prg.)
    mov al,' '  ;Ja,"."nach
getpq:stosb     ;CRLF vermeiden
getps:loop getp8
    mov cx,di
    sub cx,bp   ;CX=Lnge
getp5:dec bl
    call rdcrc
    call rdcrc  ;CRC lesen
    cmp dx,61624
    jne getp3   ;CX=Datenlnge
    mov ax,temp ;AH=Cmd/Resp/Digi,
    dec bl      ;AL=Steuerbyte
    jms getp7   ;C=0/BL=0: Ok
getp0:add si,cx
    cmp si,bufl ;Fehler: Rest
    jbe getp3   ;des Pakets
    sub si,bufl ;ignorieren
getp3:stc
getp7:mov pnt2,si
    mov si,bp   ;SI=Datenanfang
    pop bp
    ret

;Test, ob /S-Call pat
ckcall:push si di
    mov si,ofs scal
    mov di,ofs pak
    cmp by[si],0
    je ckc2     ;Kein /S-Call:C=0
ckc1:lodsb
    or al,al
    jz ckc2     ;Pat das Call?
    scasb
    je ckc1
    stc         ;C=1: Nein
ckc2:pop di si
    ret

;Zeit+Datum in UHR eintragen
time:push ax cx dx di
    mov ah,2ch  ;DOS-Zeit
    int 21h
    mov di,ofs uhr
    mov al,ch
    call al2di  ;Std.
    inc di
    mov al,cl   ;Min.
    call al2di
    inc di
    mov al,dh   ;Sek.
    call al2di
    pop di dx cx ax
    ret

;Zahl in AL zu ASCII -> [DI]
al2di:xor ah,ah
    div base
    add ax,3030h
    stosw       ;Immer 2stellig
    ret

;Test, ob Daten binr sind, oder
;ob es sich um ANSI-Text handelt;
;SI->Daten, CX=Lnge; ohne /B
;oder /C steht bei Binrdaten
;hinterher dort nur noch '##'
chkbin:push ax bx dx
    jcxz chkb0  ;Keine Daten
    test flgs,16+1 ;/B+/C:
    jnz chkb0   ;nix tun
    xor bx,bx
    xor dx,dx
    push cx si
chkb1:lodsb
    cmp al,7fh  ;Non-ASCII-
    jb chkb2    ;Bytes in
    inc bx      ;BX zhlen
    cmp al,228  ;ANSI-
    je chkb3
    cmp al,246  ;ANSI-
    je chkb3
    cmp al,252  ;ANSI-
    je chkb3
    cmp al,''  ;IBM-
    je chkb4
    cmp al,''
    je chkb4
    cmp al,''
    jne chkb2
chkb4:inc dh    ;IBM-Count
    jms chkb2
chkb3:inc dl    ;ANSI-Count
chkb2:loop chkb1
    pop si cx
    shl bx,1
    shl bx,1
    cmp bx,cx   ;4*BX > CX?
    ja chkb5    ;Ja, Binrdaten
    cmp dl,dh   ;IBM oder ANSI?
    jbe chkb0
    call ans2ibm;ANSI->IBM
    jms chkb0
chkb5:mov wp[si],'##' ;Binr:
    mov di,si   ;DI+CX korrig.,
    mov cx,2    ;## statt Binr-
    add di,cx   ;Daten anzeigen
chkb0:pop bx dx ax
    ret

;Umwandlung ANSI->IBM
;ab SI, Lnge = CX
ans2ibm:push bx cx si
ans1:mov al,[si]
    cmp al,128  ;<128 wie IBM
    jb ans2
    sub al,160
    jae ans3    ;128...159 durch
    mov al,' '  ;Space ersetzen
    jms ans4
ans3:mov bl,al
    mov al,ansi[bx]
ans4:mov [si],al
ans2:inc si
    loop ans1
ans0:pop si cx bx
    ret

;Cmd/Resp/Digi-Bits in AH anzeigen
rsp:push cx si
    mov cx,3
    mov si,ofs rspz
rsp1:shr ah,1
    jnc rsp2
    mov al,','
    call cout
    mov al,[si]
    call cout
rsp2:inc si
    loop rsp1
    pop si cx
    ret

;Steuerbyte DL mnemonisch anzeigen
cmd:push ax cx
    mov ah,dl   ;P/F-Bit ausbl.
    test ah,1
    jz cmd0     ;Info-Block
    and ah,not 10h
    cmp ah,3
    mov cx,'UI' ;UI (AX.25)
    je cmd1
    cmp ah,83h
    mov cx,'FR' ;FRMR
    je cmd1
    cmp ah,63h
    mov cx,'UA' ;UA
    je cmd1
    cmp ah,43h
    mov cx,'DI' ;DISC
    je cmd1
    cmp ah,2fh
    mov cx,'SA' ;SABM
    je cmd1
    cmp ah,0fh
    mov cx,'DM' ;DM
    je cmd1
    and ah,0fh
    cmp ah,1
    mov cx,'RR' ;RR
    je cmd4
    cmp ah,5
    mov cx,'RN' ;RNR
    je cmd4
    cmp ah,9
    mov cx,'RJ' ;REJ
    je cmd4
    mov cx,'??'
cmd4:mov al,ch  ;CX+N(S)
    call cout   ;anzeigen
    mov al,cl
    jms cmd5
cmd1:mov al,ch  ;CX anz.
    call cout
    mov al,cl
    jms cmd3
cmd0:mov al,'I' ;Info-Block
    call cout
    mov al,dl
    shr al,1
    and al,7
    add al,'0'  ;N(S) ausgeben
cmd5:call cout
    mov al,dl
    mov cl,5
    shr al,cl
    and al,7
    add al,'0'  ;N(R) ausgeben
cmd3:call cout
    test dl,10h ;P/F-Bit?
    jz cmd2
    mov al,'+'  ;Ja
    call cout
cmd2:pop cx ax
    ret

;AL aus Puffer holen, SI weiter
rdbuf:mov al,buf[si]
    inc si
    cmp si,bufl
    jb rdbuf1   ;Ringpuffer-
    xor si,si   ;Wrap
rdbuf1:ret

;AL aus Puffer holen, CRC berechnen
rdcrc:call rdbuf
    ;->crc
;Byte AL zur CRC-Prfsumme DX
crc:push bx cx
    xor dl,al
    mov bl,dl
    mov cl,4
    shl bl,cl
    xor bl,dl
    xor bh,bh
    shl bx,cl
    xor dx,bx
    shr bx,1
    xchg dl,dh
    xor dx,bx
    pop cx bx
    ret

;Im Debug-Mode (/!) AL anz.
debug:test flgs,128
    jz de1      ;/! fehlt
    call cout
    cmp al,'A'
    jb de1      ;Zustzlich
    mov ax,0e07h;Piep bei
    int 10h     ;AL >= "A"
de1:ret

;AL anzeigen
cout:push ax bx
    cmp al,7    ;BEL ignor.
    je cout1
    mov bl,7
    mov ah,0eh
    int 10h
    cmp al,13   ;CR?
    jne cout1
    test flgs,2 ;Delay?
    jz cout1
    push ds
    mov ax,40h
    mov ds,ax
    mov ah,9    ;Ja, 0.5s
cout2:mov al,ds:[6ch]
cout3:cmp al,ds:[6ch]
    je cout3
    dec ah
    jnz cout2
    pop ds
cout1:pop bx ax
    ret

;AL hexadezimal anzeigen
hex:push ax
    shr al,1
    shr al,1
    shr al,1
    shr al,1
    call hex1
    pop ax
    and al,0fh
hex1:add al,'0'
    cmp al,3ah
    jb hex2
    add al,7
hex2:jmp cout

;Pakete anzeigen (Monitor)
sho:mov ah,1
    int 16h     ;Taste?
    jz sho2
    mov ah,0
    int 16h     ;Ja, ESC?
    cmp al,27
    je sho0
sho2:call getp  ;Paket holen
    jc sho
sho4:call chkbin;Binrdaten->##
    call time   ;Zeitstempel
    call store  ;Speichern
    mov dl,al   ;Steuerbyte->DL
    mov si,ofs dta
sho1:lodsb      ;Zeit+Rufzeichen
    call cout   ;anzeigen
    cmp al,''
    jne sho1
    call cmd    ;Steuerbyte anz.
    call rsp    ;AH=Cmd/Resp/Digi
    jcxz sho    ;Keine Daten
    mov al,','
    call cout
    mov al,bh   ;PID
    call hex
    mov al,':'
    call cout
sho3:lodsb      ;Daten
    call cout
    loop sho3
    jmp sho
sho0:ret

;Klein- zu Grobuchstabe
caps:cmp al,'a'
    jb caps1
    cmp al,'z'
    ja caps1
    sub al,32
caps1:ret

;Rufzeichenweise speichern
;(Aufruf mit Reg.wie nach GETP)
store:push ax bx cx dx
    test flgs,4 ;Speichern?
    jz sto0a    ;Nein
    mov ah,al
    and ah,not 10h
    shr al,1    ;N(S) in temp[0],
    and al,7    ;Cmd in temp[1]
    mov temp,ax ;merken...
    call unnum  ;SABM,UA,DM?
    jcxz sto0a  ;Keine Daten
    call ckcall ;Pat /S-Call?
    jc sto0a
    push di si  ;Anf/Ende merken
    call mkha   ;Hash-Code->AH
    mov di,ofs pana
    mov dx,di
    mov si,ofs path
    call strcpy ;Pfad kopieren
    mov si,ofs pak
sto1:lodsb      ;Rufzeichen
    cmp al,'-'  ;mit SSID
    jb sto2     ;als Filename
    stosb
    inc cx
    jmp sto1
sto0a:jmp sto0
sto2:mov al,ah  ;Abs.-Hashcode
    stosb
    mov si,ofs ext
    call strcpy ;Extension=
    pop si di   ;.TXT, .M70
sto4:push es
    mov ax,3524h
    int 21h     ;INT 24H merken
    mov wp old24,bx
    mov wp old24[2],es
    pop es
    push dx
    mov dx,4f50h;"P" re.oben,
    call show   ;wei auf rot
    mov reob,ax
    mov dx,ofs new24
    mov ax,2524h;Abort/Retry/I.
    int 21h     ;vermeiden
    pop dx
    mov ax,3d21h
    int 21h     ;Write-Open,
    mov bx,ax   ;deny write
    jnc sto3
    xor cx,cx   ;Geht nicht:
    mov ah,3ch  ;Create
    int 21h
    jnc stoc
    mov al,''  ;Create-Error
    call debug  ;als "" anz.
    jms sto7
stoc:mov bx,ax  ;Nach Create:
    cmp hdr,0   ;Ggf. Vorspann
    jz stox     ;fr EMAIL erz.
    mov cx,hdrl
    mov dx,ofs hdr
    mov ah,40h
    int 21h
    jc sto5
    jms stox
sto3:test by temp[1],1
    jnz stox    ;Bei I-Frames
    mov ax,5700h;nach Open die
    int 21h     ;Filetime lesen:
    and cl,7    ;Paketwiederh.?
    mov al,by temp
    sub al,cl   ;AL=0,7,6:
    and al,7    ;1,2,3 Pak.wdh.!
    jz sto8     ;Normal: AL=1;
    cmp al,3    ;bis zu 2 Pakete
    ja sto8     ;knnten fehlen!
stox:mov ax,4202h
    xor cx,cx   ;Filepointer
    xor dx,dx   ;ans Dateiende
    int 21h
    mov dx,si   ;SI=Anfangsadr.
sto6:mov cx,di  ;DI=Endadr.
    sub cx,dx
    mov ah,40h  ;Write
    int 21h
    jc sto5
    cmp ax,cx   ;Error oder
    je sto9     ;Disk voll
sto5:mov ax,0e07h
    int 10h     ;Error-Piep
    mov al,'W'  ;Write Error
    call debug
    jms sto8
sto9:mov al,'>' ;Write ok
    call debug
    mov ax,5700h
    int 21h     ;N(S) in die
    and cl,not 7;drei nieder-
    or cl,by temp;wertigsten
    mov ax,5701h;Filetime-Bits
    int 21h
sto8:mov ah,3eh ;Close
    int 21h
sto7:mov dx,reob
    call show
    push ds
    lds dx,old24
    mov ax,2524h
    int 21h     ;Alter INT 24H
    pop ds
sto0:pop dx cx bx ax
    ret

;DX re.oben anzeigen,
;liefert AX=altes Zeichen
show:push ds
    mov ax,40h
    mov ds,ax
    mov ax,0b800h
    cmp by ds:[49h],7
    jne sh1
    mov ah,0b0h
sh1:mov ds,ax
    mov ax,ds:[79*2]
    mov ds:[79*2],dx
    pop ds
    ret

;SABM,UA,DM-Sonderbehandlung
;Aufruf mit AH=Steuerbyte
unnum:push bx
    mov bx,ofs satx
    cmp ah,2fh  ;SABM?
    je un1
    mov bx,ofs uatx
    cmp ah,63h  ;UA?
    je un1
    mov bx,ofs ditx
    cmp ah,43h  ;DISC?
    je un1
    mov bx,ofs dmtx
    cmp ah,0fh  ;DM?
    jne un2
un1:mov si,bx
    mov di,ofs pak+128
    call strcpy ;z.B.'UA de '
    mov si,ofs pak
un3:lodsb
    cmp al,'-'  ;Zielcall berspr.
    jae un3
un4:lodsb
    cmp al,'Z'  ;Abs.-/Fwd-Call
    ja un5      ;endet mit ""
    stosb
    jmp un4
un5:mov al,''  ;""+CRLF dahinter
    stosb
    mov ax,0a0dh
    stosw
    mov si,ofs pak+128
    mov cx,di
    sub cx,si
    mov by temp,7
    test flgs,1 ;Bei /C keine
    jz un2      ;Steuerpakete schr.
    xor cx,cx
un2:pop bx      ;N(S)=7 (0 folgt!)
    ret

;String [SI] nach [DI] kopieren
strcpy:lodsb
    stosb
    or al,al
    jnz strcpy
    dec di
    ret

;Abs.-Hash-Code ermitteln,
;SI -> Absenderrufzeichen
mkha:push si
    mov si,ofs pak
mkh0:lodsb
    cmp al,','  ;Zielrufz.
    ja mkh0     ;berlesen
    mov ah,0    ;(bis ",")
mkh1:lodsb
    cmp al,'0'  ;Absender-
    jb mkh2     ;rufzeichen
    cmp al,'Z'  ;(bis ","
    ja mkh2     ;oder "")
    add ah,al
    jmp mkh1
mkh2:and ah,1fh ;0...31 ->
    add ah,'0'  ;"0-9","A-W"
    cmp ah,'9'
    jbe mkh3
    add ah,7
mkh3:pop si
    ret

;Hauptprogramm (falls nicht resident)
main:mov sp,ofs last
    mov bx,ofs last+15
    mov cl,4
    shr bx,cl   ;Eigenen Speicher
    mov ah,4ah  ;begrenzen
    int 21h
    call sho    ;Blcke anzeigen
    call rescom ;COM rcksetzen
    mov dx,ofs qtxt
    mov ah,9
    int 21h
    mov ax,4c00h
    int 21h

;Schnittstelle initialisieren
inicom:mov dx,com
    in al,dx    ;RxD-Dummy-Read
    inc dx
    in al,dx
    jmp $+2
    cmp al,0
    jne in2a    ;IER<>0
    inc dx
    in al,dx
    and al,3fh
    cmp al,1
in2a:jne in2    ;IIR<>1
    mov dx,2
    cli
    mov pnt1,dx ;Puffer lschen
    xor dx,dx
    mov anf,dx
    mov wp buf,dx
    mov bits,8
    sti
    mov pnt2,dx
    mov al,irq
    mov cl,al
    add al,8
    push es
    mov ah,35h  ;INT merken
    int 21h
    mov wp oldi,bx
    mov wp oldi[2],es
    pop es
    mov al,cl
    add al,8
    mov ah,25h  ;INT setzen
    mov dx,ofs irqs
    int 21h     ;IRQ-Prioritt:
    mov al,0c1h ;23456701
    out 20h,al
    cli
    in al,21h   ;IRQ im PIC
    mov ah,0feh ;freigeben
    jmp $+2
    stc
    rcl ah,cl
    and al,ah
    out 21h,al
    jmp $+2
    sti
    mov cx,9999
in1:mov dx,com  ;RxD-Dummy-Read
    in al,dx
    jmp $+2
    add dl,6    ;Modem-Status-
    in al,dx    ;Dummy-Read
    jmp $+2
    loop in1
    sub dl,2
    mov al,9    ;OUT2+DTR=1
    out dx,al
    jmp $+2
    dec dx
    mov al,43h  ;TxD=+12V (Brk)
    out dx,al
    jmp $+2
    sub dl,2
    mov al,8    ;Modemstatus-
    out dx,al   ;Int.freigeben
    clc
    ret
in2:stc
    ret

;Schnittstelle rcksetzen
rescom:mov dx,es:com
    inc dx
    mov al,0
    out dx,al   ;IER sperren
    jmp $+2
    add dl,3
    out dx,al   ;OUT2+DTR+RTS=0
    jmp $+2
    dec dx
    mov al,3    ;8N1/TxD=-12V
    out dx,al
    jmp $+2
    mov cx,9999 ;IRQ-Nachzgler
    loop $      ;abwarten
    mov cl,es:irq
    cmp cl,2    ;IRQ<>2?
    je re1
    cli
    in al,21h
    jmp $+2
    mov ah,1
    shl ah,cl
    or al,ah    ;PIC sperren
    out 21h,al
    sti
re1:mov al,cl
    add al,8
    mov ah,25h
    push ds
    lds dx,es:oldi
    int 21h     ;Alter INT
    pop ds
    ret

;Diesen Text nicht berschreiben...
qtxt db 13,10,10,'PRMON beendet.',13,10,36

;File-DTA bzw. Puffer fr ein Paket
even ;Gerade Byteanzahl sollte folgen...
dta  db 13,10,16    ;CRLF+Pfeilmarke
uhr  db 'hh:mm:ss ' ;Uhrzeit
pak  db 512 dup(?)  ;Rufz.+Daten

;Empfangspuffer: Die ersten zwei
;Byte beinhalten jeweils die Lnge
;des folgenden Pakets (0=keins da),
;dann folgt das eigentliche Paket
buf  db bufl dup(?)

;Uninitialisierte Variablen
oldi  dd ?      ;Alter COM-Interrupt
old16 dd ?      ;Alter Keyb.-INT
old1c dd ?      ;Alter Timer-INT
old21 dd ?      ;Alter DOS-INT
old24 dd ?      ;Alter INT 24H
old28 dd ?      ;Alter Spooler-INT
olds  dd ?      ;User-SP+SS
dosf  dd ?      ;InDos-Flagadresse
crit  dd ?      ;DOS-Critical-Flagadr.
pnt1  dw ?      ;Rx-Pufferzeiger 1
pnt2  dw ?      ;Rx-Pufferzeiger 2
anf   dw ?      ;Zeiger auf Paketanfang
tim   dw ?      ;Letzter Timer-Wert
temp  dw ?      ;Lokal in UP verwendet
path db 48 dup(?) ;Eigener Pfad
pana db 60 dup(?) ;Pfad+Dateiname
scal db 8  dup(?) ;/S-Call

;Stack fr residente Routinen
     db 512  dup(?)
last equ this byte
;-------------Resident nur bis hier------------------

org pak ;Init-Teile im Pufferbereich...

ifndef english
dosv db 'Bentigt DOS ab 3.0',13,10,7,36
ncom db 13,10,'COM-Port nicht verwendbar',13,10,7,36
perr db 'Pfad mu Laufwerk enthalten, z.B. C:\ oder  C:\PR',13,10,7,36
ndei db 'Deinstallation nicht mglich',13,10,7,36
what db 'Packet-Radio-Monitor ',ver,'  (c) DC1YB $'
resi db ' PRMON resident geladen',13,10,36
nres db ' ESC=Ende',13,10,36
optl db 13,10
     db 'Optionen von PRMON',13,10
     db '/x  COMx statt COM1 (x=1...4)',13,10
     db '/B  Auch  Binrdaten anzeigen',13,10
     db '/C  CR nicht zu CRLF codieren',13,10
     db '/D  Zeilenweise   Verzgerung',13,10
     db '/R  Resident  (und Speichern)',13,10
     db '/S  Rufzeichenweise speichern',13,10
     db '/Sx Nur Ziel-Call x speichern',13,10,10
     db 'Mit /R ist auch /S aktiviert;',13,10
     db 'mit /C ist auch /B aktiviert;',13,10
     db 'erneut laden = deinstallieren',13,10,10
     db 'Typische Betriebsarten',13,10
     db 'a) Nicht resident:   PRMON /2',13,10
     db 'b) Resident laden: PRMON /r/2',13,10,10
     db '(c) DC1YB - Public Domain',13,10,36
else
dosv db 'Requires DOS above 3.0',13,10,7,36
ncom db 13,10,'COM port unusable or busy',13,10,7,36
perr db 'Path must contain drive, e.g. C:\ or  C:\PR',13,10,7,36
ndei db "Can't deinstall now",13,10,7,36
what db 'Packet Radio Monitor ',ver,'  (c) DC1YB $'
resi db ' PRMON is resident',13,10,36
nres db ' ESC=quit',13,10,36
optl db 13,10
     db 'Options of PRMON',13,10
     db '/x  Use COMx  instead of COM1',13,10
     db '/B  Show binary instead of ##',13,10
     db "/C  Don't add  LF  behind  CR",13,10
     db '/D  Delay after each linefeed',13,10
     db '/R  Load PRMON as a TSR prog.',13,10
     db '/S  Store files for each call',13,10
     db '/Sx Store only  for call "x"',13,10,10
     db 'Option /R  activates  /S, and',13,10
     db 'option /C  activates /B, too;',13,10
     db 'load again to deinstall PRMON',13,10,10
     db 'Typical operating modes',13,10
     db 'a) Not resident:     PRMON /2',13,10
     db 'b) Resident (TSR): PRMON /r/2',13,10,10
     db '(c) DC1YB - Public Domain',13,10,36
endif

;Programm deinstallieren
deinst:resint 16h,old16
    resint 1ch,old1c
    resint 21h,old21
    resint 28h,old28
    call rescom ;IRQ aus
    push cs     ;DS=CS
    pop ds
    mov ah,49h
    int 21h     ;RAM freig.
    mov es,es:[2ch]
    mov ah,49h  ;Envir.auch
    int 21h
    mov dx,ofs qtxt
    mov ah,9    ;Meldung
    int 21h
    mov ax,4cffh
    int 21h

;Hauptprogramm
ini:mov ax,351ch
    int 21h     ;INT 1C+28
    mov si,bx   ;prfen:
    mov ax,3528h;Schon geladen?
    int 21h
    cmp si,ofs new1c
    jne inid    ;INT 1C pat
    cmp bx,ofs new28
    je deinst   ;INT 28 auch
inie:mov dx,ofs ndei
    jms qui
inid:cmp bx,ofs new28
    je inie     ;Nur INT 28 pat
    push cs
    pop es      ;ES=CS
    mov ah,30h
    int 21h
    cmp al,3
    mov dx,ofs dosv
    jb qui
    cld
    mov si,81h
    mov di,ofs path
    mov by scal,0
ini1:lodsb
    cmp al,' '
    je ini1
    jb ini2
    cmp al,'/'  ;Option?
    je ini4
    call caps   ;Nein,Pfad
    stosb
    jmp ini1
ini6:pop di
    mov dx,ofs optl
qui:mov ah,9    ;Falsche Option
    int 21h
    mov ax,4c01h
    int 21h
ini4:lodsb
    call caps   ;Ja
    push di
    mov di,ofs ops
    mov cx,ofs opj-ops
    repne scasb
    jne ini6    ;Error
    sub di,ofs ops+1
    shl di,1    ;Gefunden...
    clc
    call opj[di]
    jc ini6
    pop di
    jmp ini1
ini2:cmp di,ofs path
    ja ini8     ;Pfad eingeg.?
    call ownp   ;Nein,eig.Pfad
    jms ini3
ini8:or flgs,4  ;Ja,/S aktivieren
ini3:mov al,'\'
    cmp al,[di-1]
    je ini5
    stosb       ;Ggf."\"ergnzen,
ini5:mov al,0   ;0 dahinter
    stosb
    mov dx,ofs perr
    cmp wp path[1],'\:'
    jne qui
    mov dx,ofs what
    mov ah,9    ;Begrung
    int 21h
    cli
    mov al,36h
    out 43h,al
    jms $+2     ;Timer 0 =
    mov al,0    ;Mode 3 (manche
    out 40h,al  ;BIOSse setzen
    jms $+2     ;zunchst Mode 2)
    out 40h,al
    sti
    call inicom ;Initialisierung
    mov dx,ofs ncom
    jc qui
    mov dx,ofs resi
    test flgs,8
    jnz inix
    mov dx,ofs nres
inix:mov ah,9
    int 21h
    test flgs,8 ;Resident?
    jnz ini7
    jmp main    ;Nein

;Resident installieren
ini7:setint 16h,old16,new16
    setint 1ch,old1c,new1c
    setint 21h,old21,new21
    setint 28h,old28,new28
    mov ah,34h  ;InDos-Flag-
    int 21h     ;Adresse
    mov wp dosf,bx
    mov wp dosf[2],es
    push ds
    mov ax,5d06h;Crit.-Error-
    int 21h     ;Flag-Adr.
    mov ax,ds
    pop ds
    mov wp crit,si
    mov wp crit[2],ax
    mov bx,4
ini9:mov ah,3eh ;TSR-Handles
    int 21h     ;schlieen
    dec bx
    jns ini9
    mov dx,ofs last
    int 27h     ;Resident

;Eigenen Pfad nach DI
ownp:mov ds,ds:[2ch]
    xor si,si   ;DS->Environment:
ownp3:lodsb     ;1.Null suchen
    or al,al
    jnz ownp3
    lodsb       ;2.Null=
    or al,al    ;Envir.-Ende?
    jnz ownp3
    lodsw       ;DS:SI=Pfadname
    cmp ax,1
    jne ownp1   ;Irgendwas faul
ownp2:lodsb     ;Pfad umspeichern
    stosb
    or al,al
    jnz ownp2
    push es     ;DS=ES (=CS)
    pop ds
ownp4:dec di
    cmp by[di],'\'
    jne ownp4   ;Zurck bis "\"
ownp1:push es
    pop ds
    ret

;Optionen und zugehr.Routinen
ops db '1234BCDERS!'
opj dw opt1,opt2,opt3,opt4,optb,optc,optd,opte,optr,opts,optde
opt1:ret        ;/1=COM1=default
opt2:mov al,com2
    mov di,wp com2[1]
opt2a:mov com,di
    mov irq,al
    ret
opt3:mov al,com3;/3=COM3
    mov di,wp com3[1]
    jmp opt2a
opt4:mov al,com4;/4=COM4
    mov di,wp com4[1]
    jmp opt2a
optb:or flgs,16 ;/B=Binrblcke
    ret         ;   auch anzeigen
optc:or flgs,1  ;/C=kein LF ergnzen
    ret         ;   (binr transp.)
optd:or flgs,2  ;/D=Delay nach
    ret         ;   angezeigtem CR
opte:mov hdr,'*';/E=EMAIL-Vorspann,
    mov ext[1],'M';.M70 statt .TXT
    mov wp ext[2],'07'
    ret
optr:or flgs,8+4;/R=resident laden
    ret         ;   und speichern
opts:mov di,ofs scal
    or flgs,4   ;/S[x]=speichern
opts0:lodsb     ;   [nur fr Call x]
    call caps
    cmp al,'/'
    je opts3
    cmp al,' '
    jbe opts3
    cmp di,ofs scal+7
    ja opts1
    cmp al,'0'
    jb opts1
    cmp al,'Z'
    ja opts1
    cmp al,'A'
    jae opts2
    cmp al,'9'
    ja opts1
opts2:stosb
    jmp opts0
opts3:dec si
    mov al,0
    stosb
    clc
    ret
opts1:stc
    ret
optde:or flgs,128
    ret
code ends
    end start
